        PAGE    60,132
        TITLE   NEWKBIOS - FORCES BIOS TO USE NEW KEYBOARD ROUTINES
COMMENT *
                 This DOS command filters all keyboard calls (INT 16H)
                 adding 10H to the AH register if the current value is
                 less than 10H when entered.  If the returned keycode
                 is E0, then force it to 00, so the new cursor keys,
                 and PgUp, PgDn, etc, look like the old keys.

        PROGRAMMER: J F GILLILAND.

        ENTRY POINTS:   +100 = STANDARD INITIAL COMMAND ENTRY
                      INTENT = INTERRUPT HANDLER ENTRY POINT

        TO ASSEMBLE:    MASM NEWKBIOS;
                        LINK NEWKBIOS;
                        EXE2BIN NEWKBIOS.EXE NEWKBIOS.COM
        *
;
PRINT   EQU     09H             ;PRINT STRING function code
;
CR      EQU     0DH             ;CARRIAGE RETURN
LF      EQU     0AH             ;LINE FEED
SPACE   EQU     20H             ;SPACE
;
CODESEG SEGMENT PARA 'CODE'
        ORG     00H
        DB      6 DUP (?)
SEGTOP  DW      ?               ;TOP OF SEGMENT IN THE PSP
        ORG     80H
PARMLEN DB      ?
PARM    DB      127 DUP (?)
        ORG     100H
        ASSUME  CS:CODESEG,DS:CODESEG,ES:CODESEG

NEWKBIOS: JMP     INSTAL                  ;GO TO INIT CODE
;
;       KEYBOARD BIOS INTERRUPT EXIT - INT 16H
;
VEC             DD      0               ;OLD KEYBOARD INT HANDLER

INTPROC PROC    FAR
INTENT: CMP     AH,10H                  ;less than 010h?
        JNB     INT16H                  ;NO, continue
        ADD     AH,10H                  ;use new keyboard BIOS
        CMP     AH,12H                  ;function 12h needs no further
        JNB     INT16H                  ; processing
        PUSHF                           ;(INT instruct pushes flags)
        CALL    DWORD PTR CS:VEC        ;simulate interrupt
        PUSHF                           ;preserve Z flag
        CMP     AL,0E0H                 ;E0 returned for ext keys
        JNE     IEXIT
        XOR     AL,AL                   ;change E0 to 00 (makes new
                                        ;cursor keys act like the old)
IEXIT:  POPF                            ;restore Z flag and return
        RET     2                       ;simulate IRET (pops flags)
INT16H: JMP     DWORD PTR CS:VEC        ;go to original handler
INTPROC ENDP
;
ENDTSR:
;       TSR CODE PRECEDES THIS POINT
;       INSTALL CODE FOLLOWS
;
MAIN    PROC    FAR
;
;       INSTALL KEYBOARD INTERCEPT
;
CMSG       DB   "NEWKBIOS copyright 1987 J. F. Gilliland",CR,LF,"$"
INMSG      DB   "NEWKBIOS installed",CR,LF,"$"
WRONGMSG   DB   "This BIOS does not support the enhanced keyboard",CR,LF
           DB   "NEWKBIOS not installed",CR,LF,"$"

INSTAL: MOV     DX,OFFSET CMSG
        MOV     AH,PRINT
        INT     21H                     ;display copyright message
        MOV     AH,12H                  ;if the 12H function of
        INT     16H                     ; int 16H doesn't return zero
        OR      AH,AH                   ; in AH, then this is the
        JNZ     WRONG                   ; old BIOS; DO NOT INSTALL
        PUSH    DS
        XOR     AX,AX
        MOV     DS,AX                   ;DS points to low memory
        MOV     AX,WORD PTR DS:0058H    ;SAVE OLD VECTOR
        MOV     WORD PTR CS:VEC,AX
        MOV     AX,WORD PTR DS:005AH
        MOV     WORD PTR CS:VEC+2,AX
        MOV     AX,(OFFSET INTENT)
        MOV     WORD PTR DS:0058H,AX    ;INSTALL NEW VECTOR
        MOV     AX,CS
        MOV     WORD PTR DS:005AH,AX
        POP     DS
        MOV     DX,OFFSET INMSG
        MOV     AH,PRINT
        INT     21H                     ;'NEWKBIOS INSTALLED'
;
;       EXIT LEAVING ME IN MEMORY
;
        MOV     DX,OFFSET ENDTSR        ;TSR code pointer
        INT     27H                     ;EXIT BUT STAY RESIDENT
;
WRONG:  MOV     DX,OFFSET WRONGMSG
        MOV     AH,PRINT
        INT     21H                     ;WRONG KEYBOARD BIOS message
        MOV     AH,4CH                  ;new function code for exit
        MOV     AL,16                   ;return code 16
        INT     21H                     ;EXIT - NO INSTALL
MAIN    ENDP
;
CODESEG ENDS
        END     NEWKBIOS
